VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "FileIO"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Option Compare Text

Private Function FileExist(fil As String) As Boolean
Dim F As Long
On Error Resume Next
F = FreeFile
Open fil For Input As #F
If Err = 0 Then
    Close #F
    FileExist = True
Else
    Err.Clear
    FileExist = False
End If
End Function

'nacteni souboru
Sub Nacti(fil As String)
Dim F As Long, buf As String
If FileExist(fil) Then
    F = FreeFile
    Open fil For Binary As #F
        buf = String(LOF(F), Chr$(0))
        Get #F, , buf
    Close #F
    
    StringNaOsoby Replace$(buf, vbLf, vbCrLf)
End If
End Sub

Private Function SubStr(kde As String, od As Long, d As Long) As String
SubStr = Mid$(kde, od, d - od + 1)
If Left$(SubStr, 1) = "<" Then SubStr = Right$(SubStr, Len(SubStr) - 1)
If Right$(SubStr, 1) = ">" Then SubStr = Left$(SubStr, Len(SubStr) - 1)
End Function

'prevede xml soubor na kolekci osob
Private Sub StringNaOsoby(buf As String)
Dim Pos As Long, Pos2 As Long

Osoby.Clear
buf = Replace$(buf, vbCrLf, " ")
Pos = InStr(buf, "<rodokmen>")
Pos2 = InStr(buf, "</rodokmen")
If Not ((Pos = 0) Or (Pos2 = 0)) Then
    ZpracujRodokmen SubStr(buf, Pos + 10, Pos2 - 1)
End If
End Sub

Private Sub ZpracujRodokmen(buf As String)
Dim Pos As Long, Pos2 As Long, temp As String, tmp As String
temp = buf

Do
    Pos = InStr(temp, "<osoba>")
    Pos2 = InStr(temp, "</osoba>")
    If (Pos2 = 0) And (Pos = 0) Then Exit Do 'zadna dalsi osoba
    tmp = SubStr(temp, Pos + 7, Pos2 - 1)
    ZpracujOsobu tmp
    temp = Right$(temp, Len(temp) - Pos2 - 8)
Loop
End Sub

Private Sub ZpracujOsobu(buf As String)
Dim os As Osoba

Set os = New Osoba
With os
    .ID = MeziTagy(buf, "id")
    .Jmeno = MeziTagy(buf, "jmeno")
    .Prijmeni = MeziTagy(buf, "prijmeni")
    .Pohlavi = MeziTagy(buf, "pohlavi")
    .Narozeni = MeziTagy(buf, "narozeni")
    .Umrti = MeziTagy(buf, "umrti")
    .Matka = MeziTagy(buf, "matka")
    .Otec = MeziTagy(buf, "otec")
End With
Osoby.Add os
End Sub

Private Function MeziTagy(kde As String, tag As String) As String
Dim Pos As Long, Pos2 As Long, temp As String

Pos = InStr(kde, "<" + tag + ">")
Pos2 = InStr(kde, "</" + tag + ">")
If Not ((Pos = 0) Or (Pos2 = 0)) Then
    MeziTagy = Trim$(SubStr(kde, Pos + 2 + Len(tag), Pos2 - 1))
End If
End Function

Private Function UlozTag(ByVal tag As String, ByRef data As String)
If data = "" Then
    UlozTag = "<" + tag + "/>"
Else
    UlozTag = "<" + tag + ">" + data + "</" + tag + ">"
End If
End Function

Sub Uloz(fil As String)
Dim os As Osoba, F As Long, mez As String, mez2 As String
    
mez = Space$(5)
mez2 = Space$(10)

F = FreeFile
On Error GoTo errZprac
Open fil For Output As #F

Print #F, "<rodokmen>"
For Each os In Osoby
    With os
        Print #F, mez + "<osoba>"
        Print #F, mez2 + UlozTag("id", .ID)
        Print #F, mez2 + UlozTag("jmeno", .Jmeno)
        Print #F, mez2 + UlozTag("prijmeni", .Prijmeni)
        Print #F, mez2 + UlozTag("pohlavi", .Pohlavi)
        Print #F, mez2 + UlozTag("narozeni", .Narozeni)
        Print #F, mez2 + UlozTag("umrti", .Umrti)
        Print #F, mez2 + UlozTag("matka", .Matka)
        Print #F, mez2 + UlozTag("otec", .Otec)
        Print #F, mez + "</osoba>"
    End With
Next
Print #F, "</rodokmen>"
Close #F
MsgBox "Uloen souboru probhlo spn!", vbInformation
Exit Sub

errZprac:
    MsgBox "Pi ukldn dolo k chzb!", vbCritical
End Sub
