VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmRodokmen 
   Caption         =   "Rodokmen - m38"
   ClientHeight    =   7515
   ClientLeft      =   60
   ClientTop       =   630
   ClientWidth     =   9930
   LinkTopic       =   "Form1"
   ScaleHeight     =   7515
   ScaleWidth      =   9930
   StartUpPosition =   2  'CenterScreen
   Begin MSComDlg.CommonDialog cdl 
      Left            =   3360
      Top             =   1560
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      DefaultExt      =   "xml"
      DialogTitle     =   "Rodokmen"
      Filter          =   "XML soubory (*.xml)|*.xml|Vechny soubory (*.*)|*.*"
   End
   Begin VB.PictureBox picCont 
      BackColor       =   &H00FFFFFF&
      Height          =   5775
      Left            =   120
      ScaleHeight     =   5715
      ScaleWidth      =   7395
      TabIndex        =   0
      Top             =   120
      Width           =   7455
      Begin VB.CommandButton cmdVpravo 
         Caption         =   ">"
         Height          =   375
         Left            =   600
         TabIndex        =   3
         Top             =   120
         Width           =   495
      End
      Begin VB.CommandButton cmdVlevo 
         Caption         =   "<"
         Height          =   375
         Left            =   120
         TabIndex        =   2
         Top             =   120
         Width           =   495
      End
      Begin m38.ucOsoba ucOsoby 
         Height          =   495
         Index           =   0
         Left            =   705
         TabIndex        =   1
         Top             =   600
         Visible         =   0   'False
         Width           =   2055
         _ExtentX        =   3625
         _ExtentY        =   873
      End
   End
   Begin VB.Menu mnuSoubor 
      Caption         =   "&Soubor"
      Begin VB.Menu mnuNovy 
         Caption         =   "Nov"
         Enabled         =   0   'False
         Shortcut        =   ^N
      End
      Begin VB.Menu mnuOtevrit 
         Caption         =   "Otevt"
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuUlozit 
         Caption         =   "Uloit"
         Shortcut        =   ^S
      End
      Begin VB.Menu mnuO1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuKonec 
         Caption         =   "Konec"
         Shortcut        =   ^X
      End
   End
   Begin VB.Menu mnuOsoby 
      Caption         =   "&Osoby"
      Begin VB.Menu mnuNovaOs 
         Caption         =   "Nov"
      End
   End
   Begin VB.Menu mnuInfo 
      Caption         =   "&Info"
   End
End
Attribute VB_Name = "frmRodokmen"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const MEZERA As Long = 10 * 15 '10px
Private Const HMEZERA As Long = 40 * 15 '10px

Private Sub cmdVlevo_Click()
Dim i As Long
For i = ucOsoby.LBound To ucOsoby.UBound
    ucOsoby(i).Left = ucOsoby(i).Left + 1500
Next i
End Sub

Private Sub cmdVpravo_Click()
Dim i As Long
For i = ucOsoby.LBound To ucOsoby.UBound
    ucOsoby(i).Left = ucOsoby(i).Left - 1500
Next i
End Sub

Private Sub Form_Load()
cdl.Flags = cdlOFNHideReadOnly Or cdlOFNFileMustExist Or cdlOFNOverwritePrompt

'TOHLE ODSTRANIT
Form_Resize
NactiSoubor CestaProg + "data\simpsons.xml"
End Sub

Private Sub Form_Resize()
picCont.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

Private Sub mnuInfo_Click()
frmAbout.Show
End Sub

Private Sub mnuKonec_Click()
On Error Resume Next
Unload Me
End Sub

Private Sub mnuNovaOs_Click()
Dim pocet As Long, Os As Osoba
pocet = ucOsoby.UBound + 1
Load ucOsoby(pocet)
With ucOsoby(pocet)
    .Move 0, 0
    .Visible = True
End With
Set Os = New Osoba
frmInfo.NovaOs Os
If Os.ID = "" Then Unload ucOsoby(pocet): Exit Sub
Osoby.Add Os
NactiDoUC ucOsoby(pocet), Os.ID
Umisteni
End Sub

Private Sub mnuOtevrit_Click()
On Error Resume Next
cdl.InitDir = CestaProg
cdl.ShowOpen
If Not Err = 0 Then
    Err.Clear
Else
    NactiSoubor cdl.FileName
End If
End Sub

Private Sub NactiSoubor(fil As String)
Dim i As Long, Os As Osoba, pocet As Integer
For i = 1 To ucOsoby.UBound
    Unload ucOsoby(i)
Next
FileIO.Nacti fil
For Each Os In Osoby
    pocet = pocet + 1
    Load ucOsoby(pocet)
    NactiDoUC ucOsoby(pocet), Os.ID
    ucOsoby(pocet).Visible = True
    ucOsoby(pocet).Move 0, 0
Next
Umisteni
End Sub

Private Sub Spoj(ID1 As String, ID2 As String, Optional Barva As Long = vbBlack)
Dim uc1 As Integer, uc2 As Integer
Dim i As Long

For i = ucOsoby.LBound To ucOsoby.UBound
    If ucOsoby(i).ID = ID1 Then uc1 = i
    If ucOsoby(i).ID = ID2 Then uc2 = i
Next

'stredy
Dim sx1 As Single, sx2 As Single, sy1 As Single, sy2 As Single
With ucOsoby(uc1)
    sx1 = .Left + (.Width / 2)
    sy1 = .Top + (.Height / 2)
End With
With ucOsoby(uc2)
    sx2 = .Left + (.Width / 2)
    sy2 = .Top + (.Height / 2)
End With
'picCont.DrawWidth = 1
picCont.Line (sx1, sy1)-(sx2, sy2), Barva
DoEvents
End Sub

Private Sub SpocitejPotomkyASourozence()
Dim Os As Osoba, os2 As Osoba, max As Long
max = 0
For Each Os In Osoby
    For Each os2 In Osoby
        If (Os.ID = os2.Matka) Or (Os.ID = os2.Otec) Then
            Os.Potomci = Os.Potomci + 1
        End If
        If (Os.Matka = os2.Matka) Or (Os.Otec = os2.Otec) Then 'pripadne and
            Os.Sourozenci = Os.Sourozenci + 1
        End If
    Next
Next
End Sub

Private Sub RecRodice(tX As Long, potomek As Osoba)
Dim Os As Osoba
For Each Os In Osoby
    If (potomek.Matka = Os.ID) Or (potomek.Otec = Os.ID) Then
        With ucOsoby(UCIndex(Os.ID))
            .Move tX, ucOsoby(UCIndex(potomek.ID)).Top - HMEZERA - .Height
            tX = tX + .Width + MEZERA
        End With
        RecRodice tX, Os
    End If
Next
End Sub

Private Sub Umisteni()
Dim x As Long, y As Long, Os As Osoba

SpocitejPotomkyASourozence
y = picCont.ScaleHeight - ucOsoby(0).Height - HMEZERA
x = 0
For Each Os In Osoby
    If Os.Potomci = 0 Then
        With ucOsoby(UCIndex(Os.ID))
            .Move x, y
            x = x + .Width + MEZERA
            RecRodice 0, Os
        End With
    End If
Next
End Sub

Private Sub mnuUlozit_Click()
On Error Resume Next
cdl.InitDir = CestaProg
cdl.DefaultExt = "xml"
cdl.ShowSave
If Not Err = 0 Then
    Err.Clear
Else
    FileIO.Uloz cdl.FileName
End If
End Sub

Private Sub picCont_Paint()
SpojitVse
End Sub

Private Sub ucOsoby_InfoClick(Index As Integer)
frmInfo.ShowMe ucOsoby(Index).ID
NactiDoUC ucOsoby(Index), ucOsoby(Index).ID
Umisteni
End Sub

Private Function UCIndex(ID As String) As Integer
Dim i As Long
UCIndex = -1
For i = ucOsoby.LBound To ucOsoby.UBound
    If ucOsoby(i).ID = ID Then UCIndex = i: Exit Function
Next
End Function

Private Sub SpojitVse()
Dim Os As Osoba, os2 As Osoba
picCont.Cls
For Each Os In Osoby
    If Not Os.Matka = "" Then Spoj Os.ID, Os.Matka
    If Not Os.Otec = "" Then Spoj Os.ID, Os.Otec
    For Each os2 In Osoby
        'test sourozencu
        If Not (Os.Matka = "") Then
            If (Os.Matka = os2.Matka) Then Spoj Os.ID, os2.ID, vbBlue
        End If
        If Not (Os.Otec = "") Then
            If (Os.Otec = os2.Otec) Then Spoj Os.ID, os2.ID, vbBlue
        End If
        
        'test manzelu
        If Not ((Os.Matka = "") Or (Os.Otec = "")) Then
            If ((Os.Matka = os2.Matka) And (Os.Otec = os2.Otec)) Then
                Spoj Os.Matka, os2.Otec, vbRed
            End If
        End If
    Next
Next
End Sub
